; Jaws for Windows 3.71 Scripts for Napster 2.0 Beta 10.4
;
; Written by
; Bryan Garaventa
; QA Engineer
; bgaraventa@napster.com
; Napster, Inc.
;
; Last Revised- 08/30/2001
;
; Some of the following scripts were written using the default.jss
; source code file as a reference.
;
Include "hjconst.jsh"
Include "hjglobal.jsh"
Include "HjHelp.jsh"
Include "default.jsm"

globals
int napsterFirstTime,
int iXCurrentCol,
int iYCurrentRow,
int iXPreviousCol,
int iYPreviousRow,
string strCW,
string strPW,
int DC,
int CT,
int cc,
int pc,
int currentSetting,
int prevSetting,
string cl,
string nl,
int be,
int prevp,
int clearS,
int clearM,
int clearT,
int otrans,
int et,
int sb,
int ink,
int AddUser,
int uInfo,
int uCol,
int uRow

Void Function AutoStartEvent ()
let sb = false
let DC = false
let prevp = GetJCFOption (opt_punctuation)
Pause ()
RouteJAWSToPc ()
While (GetWord () == "Cancel")
Delay (5)
RouteJAWSToPc ()
EndWhile
Say ("Application Ready", OT_STRING)
If (napsterFirstTime == false) then
let napsterFirstTime = true
Say ("Welcome to Napster!", OT_STRING)
endIf
EndFunction

Void Function AutoFinishEvent ()
let sb = false
let DC = false
let clearT = false
let clearS = false
let clearM = false
SetJCFOption (opt_punctuation, prevp)
PCCursor ()
EndFunction

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey,
int menusactive)
Var
string strT,
handle FocusWindow,
handle RealWindow,
string RealWindowName,
handle AppWindow,
int PrevMenuMode,
int TheTypeCode,
int nSetting,
int NCurrentMSAAMode
; Modifications for Windows 2000
; Added 3/2/2000 by MikeP and DaveB
Let TheTypeCode = GetObjectSubTypeCode()
let PrevMenuMode = GlobalMenuMode
let GlobalPrevMenuMode = PrevMenuMode
If (ink == true) then
SayInteger (NKey)
let ink = false
endIf
If (strKeyName == "Enter") then
If ((NKey == 18) &&
(strKeyName == "e")) then
else
if (DC == true) then
SaveCursor ()
let DC = false
PCCursor ()
InputBox ("Type message to send.", "MessageBox", strT)
let CT = true
SpeechOff ()
{control+a}
Pause ()
If (GetObjectType () == "Edit") then
TypeString (strT)
Pause ()
EnterKey ()
Pause ()
PerformScript EnterScanNewMessages()
Pause ()
{control}
Pause ()
{control}
Pause ()
{control}
Pause ()
SpeechOn ()
RestoreCursor ()
let CT = false
endIf
endIf
If (GetObjectType () == "List View") then
If (GlobalMenuMode == MENU_INACTIVE) then
	If (PrevMenuMode == MENUBAR_ACTIVE) then
else
RouteJAWSToPc ()
GetCursorRow ()
GetCursorCol () 
let iXCurrentCol = GetCursorCol ()
let iYCurrentRow = GetCursorRow ()
let iXPreviousCol = iXCurrentCol
Let iYPreviousRow = iYCurrentRow
PerformScript ContextMenu()
Pause ()
let iXCurrentCol = GetCursorCol ()
let iYCurrentRow = GetCursorRow ()

If ((iXCurrentCol == iXPreviousCol) &&
(iYCurrentRow == iYPreviousRow) &&
(GetWindowName (GetRealWindow (GetFocus ())) == "Napster Chat Rooms")) then
JoinR ()
endIf
endIf
Return
endIf
else
If (GetControlName () == "Artist") then
Pause ()
FindString (GetCurrentWindow (), "Cancel", S_TOP, S_UNRESTRICTED)
If (GetWord () != "Cancel") then
else
While (GetWord () == "Cancel")
Delay (5)
FindString (GetCurrentWindow (), "Cancel", S_TOP, S_UNRESTRICTED)
EndWhile
PCCursor ()
PerformScript ViewSearchResults()
endIf
else
If (GetControlName () == "Title") then
Pause ()
FindString (GetCurrentWindow (), "Cancel", S_TOP, S_UNRESTRICTED)
If (GetWord () != "Cancel") then
else
While (GetWord () == "Cancel")
Delay (5)
FindString (GetCurrentWindow (), "Cancel", S_TOP, S_UNRESTRICTED)
EndWhile
PCCursor ()
PerformScript ViewSearchResults()
endIf
else
If ((DialogActive ()) &&
(GetObjectType () == "Edit") &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Instant Message"))) then
ScheduleFunction ("FocusPointSchedule", 20)
endIf
endIf
endIf
endIf
endIf
endIf
If (strKeyName == "Space") then
If (sb == true) then
ResetChat ()
endIf
endIf
EndFunction

Void Function MenuModeEvent (handle WinHandle, int mode)
;The Mode parameter indicates whether the menuBar has become active, a
;Menu  has become active, or the menus are going away.  These are
;represented by the constants MENUBAR_ACTIVE, MENU_ACTIVE, and
;MENU_INACTIVE.
Var
	handle FocusWindow,
	handle RealWindow,
	string RealWindowName,
	handle AppWindow,
	int PrevMenuMode,
	int TheTypeCode,
	int nSetting,
	int NCurrentMSAAMode
; Modifications for Windows 2000
; Added 3/2/2000 by MikeP and DaveB
let sb = false
let DC = false
Let TheTypeCode = GetObjectSubTypeCode()
let PrevMenuMode = GlobalMenuMode
let GlobalPrevMenuMode = PrevMenuMode
let GlobalMenuMode=mode
let NCurrentMSAAMode=GetJCFOption (	OPT_MSAA_MODE)
If (mode == MENU_INACTIVE) then
	If (PrevMenuMode == MENUBAR_ACTIVE) then
		SayMessage (ot_jaws_message, msg58_L) ;"leaving menu bar"
	else
		SayMessage (ot_jaws_message, msg59_L) ;"Leaving menus"
	endIf
	return
endIf ; menu inactive
if (GetWindowSubTypeCode (WinHandle) == WT_CONTEXTMENU) then
	SayMessage (ot_jaws_message, msg5_L) ;"Context Menu"
	{down arrow}; 95, say first item in menu
	MenuModeHook ()
	return
endIf
If (mode == MENUBAR_ACTIVE) then
SayMessage (ot_jaws_message, msg56_L) ;"	Menu bar"
	MenuModeHook ()
	If (nCurrentMSAAMode >= 1) then
	; Only do this if GetWord does not return a value
	; Because in Windows 2K this is the case
	; even though a menu bar option is selected
		If (GetWord () == msgNull_L) then
			SayObjectActiveItem ()
			Return
		endIf
		If (GetWindowSubTypeCode (GetCurrentWindow ()) != WT_TOOLBAR) then
			If (! (GetCharacterAttributes () & ATTRIB_HIGHLIGHT)) then
				if (GetWindowClass(GetCurrentWindow())!= "MsoCommandBar")	then
					SayObjectActiveItem ()
				endIf
				Return
			endIf
		endIf
	endIf
	Return
endIf ; menu bar active
If (mode == MENU_ACTIVE) then
	If GetWindowSubTypeCode(WinHandle) == WT_STARTMENU then
		SayMessage (OT_JAWS_MESSAGE, msg4_L) ;"Start Menu"
		{down arrow} ; 95, say first item in menu
else
		SayMessage (ot_jaws_message, msg57_L) ;"Menu active"
	endIf ; if start menu
	MenuModeHook ()
	return
endIf ; menu active

let FocusWindow = GetFocus()
If (FocusWindow == GlobalPrevFocus) then
	let RealWindow = GetRealWindow(FocusWindow)
	let RealWindowName = GetWindowName (RealWindow)
	let AppWindow = GetAppMainWindow(FocusWindow)
	if (RealWindow != FocusWindow) then
		SayWindowTypeAndText(RealWindow)
	endIf ; verbosity beginner
	;no matter what, say the window with focus
	SayWindowTypeAndText(FocusWindow)
endIf ; focus window = global prev focus
MenuModeHook()
EndFunction

Void Function MenuModeHook ()
EndFunction

Void Function FocusPointMovedEvent (int nX, int nY, int nOldX, int nOldY, int nUnit, int nDir, int nTimeElapsed)
If (DC == false) then
FocusPointSchedule ()
endIf
If (DC == true) then
PubChatSchedule ()
endIf
EndFunction

Script Exit ()
let sb = false
let DC = false
SpeechOff ()
If ((DialogActive ()) &&
(GetObjectType () == "Edit") &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Instant Message"))) then
PCCursor ()
{alt+f4}
SpeechOn ()
Pause ()
else
PCCursor ()
If (MenusActive ()) then
{alt}
Pause ()
endIf
{alt+f}
Pause ()
{x}
Pause ()
SpeechOn ()
PCCursor ()
Say ("Have a nice day!", OT_STRING)
endIf
EndScript

Script ViewSearchResults ()
let sb = false
let DC = false
SpeechOff ()
{control+s}
Pause ()
{tab}
Pause ()
{tab}
Pause ()
{tab}
Pause ()
{tab}
Pause ()
SpeechOn ()
PCCursor ()
{tab}
Pause ()
RouteJAWSToPc ()
EndScript

Script ContextMenu ()
RouteJAWSToPc ()
RightMouseButton ()
EndScript

Void Function FocusNextSDMControl ()
let sb = false
let DC = false
RouteJAWSToPc ()
MoveToNextSdmControl ()
PCCursor ()
RoutePcToJAWS ()
EndFunction

Script HomeDiscoverPageView ()
let sb = false
let DC = false
FocusNextSDMControl ()
EndScript

Void Function TransferPageView ()
let sb = false
let DC = false
RouteJAWSToPc ()
FindString (GetCurrentWindow (), "Filename", S_TOP, S_UNRESTRICTED)
JAWSCursor ()
NextLine ()
JAWSHome ()
PCCursor ()
LeftMouseButton ()
Pause ()
If (GetObjectType () != "List View") then
Say ("No transfers visible", OT_STRING)
endIf
EndFunction

Void Function MyFiles ()
let sb = false
let DC = false
SpeechOff ()
RouteJAWSToPc ()
FindString (GetCurrentWindow (), "Filename", S_TOP, S_UNRESTRICTED)
JAWSCursor ()
NextLine ()
JAWSHome ()
SpeechOn ()
PCCursor ()
LeftMouseButton ()
Delay (3)
If (GetObjectType () != "List View") then
Say ("no files listed", OT_STRING)
endIf
EndFunction

Script Playlist ()
let sb = false
let DC = false
SpeechOff ()
SaveCursor ()
{control+m}
Pause ()
FindString (GetCurrentWindow (), "Playlist", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () == "Playlist") then
SpeechOn ()
PCCursor ()
Say ("no files listed", OT_STRING)
Say ("Back to My Files", OT_STRING)
RestoreCursor ()
SayLine ()
else
FindString (GetCurrentWindow (), "Internal Audio Player", S_BOTTOM, S_UNRESTRICTED)
NextLine ()
JAWSHome ()
SpeechOn ()
PCCursor ()
LeftMouseButton ()
endIf
EndScript

Script Add ()
let sb = false
let cc = GetCursorCol ()
let pc = GetCursorRow ()
let DC = false
If (AddUser == true) then
SpeechOff ()
FindString (GetCurrentWindow (), "Add User to Hot List", S_BOTTOM, S_UNRESTRICTED)
LeftMouseButton ()
Pause ()
Delay (1)
If Not (DialogActive ()) then
SpeechOn ()
PCCursor ()
SayObjectActiveItem ()
Pause ()
Say ("Back to message window", OT_STRING)
Pause ()
{alt+tab}
Pause ()
RouteJAWSToPc ()
JAWSCursor ()
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
RoutePcToJAWS ()
PCCursor ()
else
SpeechOn ()
PerformScript Test()
endIf
else
If (clearM == true) then
SaveCursor ()
GetCursorCol ()
GetCursorRow ()
SpeechOff ()
FindString (GetCurrentWindow (), "Add", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Add") then
SpeechOn ()
PCCursor ()
Say ("My Files page not visible", OT_STRING)
RestoreCursor ()
Else
PCCursor ()
LeftMouseButton ()
Pause ()
SpeechOn ()
PCCursor ()
Say ("Okay, Back to My Files", OT_STRING)
RouteJAWSToPc ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf
endIf
endIf
EndScript

Script Remove ()
let sb = false
let DC = false
SaveCursor ()
SpeechOff ()
{control+m}
Pause ()
FindString (GetCurrentWindow (), "Remove", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Remove") then
SpeechOn ()
PCCursor ()
Say ("My Files page not visible", OT_STRING)
RestoreCursor ()
Else
PCCursor ()
LeftMouseButton ()
Pause ()
SpeechOn ()
PerformScript Playlist()
Pause ()
If (GetWord () == "Remove") then
MyFiles ()
endIf
endIf
EndScript

Script Save ()
let sb = false
let DC = false
SaveCursor ()
SpeechOff ()
{control+m}
Pause ()
FindString (GetCurrentWindow (), "Save", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Save") then
SpeechOn ()
PCCursor ()
Say ("My Files page not visible", OT_STRING)
RestoreCursor ()
Else
PCCursor ()
LeftMouseButton ()
SpeechOn ()
Pause ()
endIf
EndScript

Script Load ()
let sb = false
let DC = false
SaveCursor ()
SpeechOff ()
{control+m}
Pause ()
FindString (GetCurrentWindow (), "Load", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Load") then
SpeechOn ()
PCCursor ()
Say ("My Files page not visible", OT_STRING)
RestoreCursor ()
Else
PCCursor ()
SpeechOn ()
LeftMouseButton ()
Pause ()
endIf
EndScript

Script Clear ()
let sb = false
let DC = false

SaveCursor ()
If (clearM == true) then
SpeechOff ()
FindString (GetCurrentWindow (), "Clear", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Clear") then
SpeechOn ()
PCCursor ()
Say ("My Files page not visible", OT_STRING)
RestoreCursor ()
Else
LeftMouseButton ()
Pause ()
SpeechOn ()
PCCursor ()
Say ("Okay", OT_STRING)
MyFiles ()
Pause ()
endIf
ElIf (clearS == true) then
SpeechOff ()
{control+s}
Pause ()
{tab}
Pause ()
{tab}
Pause ()
{tab}
Pause ()
{space}
SpeechOn ()
{control+s}
Pause ()
ElIf (clearT == true) then
let cc = GetCursorCol ()
let pc = GetCursorRow ()
SaveCursor ()
FindString (GetCurrentWindow (), "Clear Finished", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Clear Finished") then
PCCursor ()
Say ("Button not found", OT_STRING)
RestoreCursor ()
else
SpeechOff ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
MoveTo (cc, pc)
RoutePcToJAWS ()
If (GetObjectType () == "List View") then
SpeechOn ()
SayObjectActiveItem ()
else
SpeechOn ()
endIf
Return
endIf
else
RestoreCursor ()
Say ("No items in view", OT_STRING)
endIf
EndScript

Script Chat ()
let sb = false
let DC = false
SaveCursor ()
SpeechOff ()
{control+a}
Pause ()
SpeechOn ()
RouteJAWSToPc ()
FindString (GetCurrentWindow (), "Chat Rooms", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Chat") then
RestoreCursor ()
Say ("key stroke temporarily invalid", OT_STRING)
else
SpeechOff ()
PCCursor ()
LeftMouseButton ()
Pause ()
Delay (1)
let cl = GetWord ()
let nl = cl
GetWord ()
NextLine ()
let cl = GetWord ()
If (cl != nl) then
SpeechOn ()
PriorLine ()
else
SpeechOn ()
SayObjectActiveItem ()
endIf
endIf
EndScript

Script BrowseFiles ()
let sb = false
let DC = false
SpeechOff ()
PerformScript ContextMenu()
Pause ()
{b}
Pause ()
Delay (3)
{tab}
Pause ()
SpeechOn ()
{tab}
Pause ()
EndScript

Script SearchPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearS = true
let clearT = false
let clearM = false
TypeCurrentScriptKey ()
EndScript

Script HomePage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearT = false
let clearS = false
let clearM = false
TypeCurrentScriptKey ()
EndScript

Script TransferPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
SpeechOff ()
{control+s}
Pause ()
SpeechOn ()
let clearT = true
let clearS = false
let clearM = false
TypeCurrentScriptKey ()
Pause ()
If (otrans == false) then
TransferPageView ()
endIf
EndScript

Script MyFilesPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearT = false
let clearS = false
let clearM = true
TypeCurrentScriptKey ()
Pause ()
MyFiles ()
EndScript

Script HotListPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearT = false
let clearS = false
let clearM = false
TypeCurrentScriptKey ()
EndScript

Script DiscoverPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearT = false
let clearS = false
let clearM = false
TypeCurrentScriptKey ()
EndScript

Script ChatPage ()
let sb = false
SetJCFOption (opt_punctuation, prevp)
let DC = false
let clearT = false
let clearS = false
let clearM = false
SpeechOff ()
TypeCurrentScriptKey ()
Pause ()
If (CT == false) then
Delay (3)
{tab}
Pause ()
let cl = GetWord ()
let nl = cl
GetWord ()
NextLine ()
let cl = GetWord ()
If (cl != nl) then
SpeechOn ()
PriorLine ()
else
SpeechOn ()
SayObjectActiveItem ()
endIf
endIf
SpeechOn ()
EndScript

Script Test ()
PCCursor ()
If (GetControlID (GetCurrentWindow ()) == 32837) then
SpeechOff ()
RouteJAWSToPc ()
JAWSCursor ()
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
MoveToWindow (GetPriorWindow (GetCurrentWindow ()))
RoutePcToJAWS ()
PCCursor ()
SpeechOn ()
Return
endIf
PCCursor ()
If ((DialogActive ()) &&
(GetObjectType () == "Edit") &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Instant Message"))) then
let sb = false
let DC = false
let AddUser = true
SaveCursor ()
SpeechOff ()
FindString (GetCurrentWindow (), "Add User to Hot List", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Add User to Hot List") then
SpeechOn ()
RestoreCursor ()
else
FindGraphic (GetCurrentWindow (), "Scroll Down", S_BOTTOM, S_UNRESTRICTED)
If (GetCharacter () == "Scroll Down") then
SpeechOn ()
PCCursor ()
TypeString ("Could you send that last message again? Thanks.")
EnterKey ()
Pause ()
Say ("Screen full, window closing, just wait for reply", OT_STRING)
{Alt+F4}
Pause ()
else
SpeechOff ()
RouteJAWSToPc ()
FindString (GetCurrentWindow (), ">", S_BOTTOM, S_UNRESTRICTED)
If (GetCharacter () != ">") then
SpeechOn ()
RestoreCursor ()
else
SpeechOn ()
SayUsingVoice (VCTX_PCCURSOR, GetToEndOfLine (), OT_STRING)
NextLine ()
JAWSHome ()
While (GetWord () != "Add User to Hot List")
SayUsingVoice (VCTX_PCCURSOR, GetToEndOfLine (), OT_STRING)
NextLine ()
JAWSHome ()
EndWhile
PCCursor ()
EndIf
endIf
endIf
endIf
SpeechOn ()
PCCursor ()
EndScript

Void Function FocusPointSchedule (int nX, int nY, int nOldX, int nOldY, int nUnit, int nDir, int nTimeElapsed)
If Not ((DialogActive ()) &&
(GetObjectType () == "Edit") &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Instant Message"))) then
Return
else
let sb = false
let DC = false
SetJCFOption (opt_punctuation, 0)
SaveCursor ()
SpeechOff ()
ScheduleFunction ("FocusPointSchedule", 20)
FindGraphic (GetCurrentWindow (), "Scroll Down", S_BOTTOM, S_UNRESTRICTED)
If (GetCharacter () == "Scroll Down") then
FindGraphic (GetCurrentWindow (), "Maximize", S_TOP, S_UNRESTRICTED)
If (GetCharacter () == "Maximize") then
SpeechOn ()
PCCursor ()
LeftMouseButton ()
Pause ()
else
SpeechOn ()
PCCursor ()
TypeString ("Could you send that last message again? Thanks.")
EnterKey ()
Pause ()
Say ("Screen full, window closing, just wait for reply", OT_STRING)
{Alt+F4}
Pause ()
endIf
else
FindString (GetFocus (), ">", S_BOTTOM, S_UNRESTRICTED)
If (GetCharacter () != ">") then
SpeechOn ()
RestoreCursor ()
Return
else
GetCursorRow ()
GetCursorCol () 
let iXCurrentCol = GetCursorCol ()
let iYCurrentRow = GetCursorRow ()
let iXPreviousCol = iXCurrentCol
Let iYPreviousRow = iYCurrentRow
RestoreCursor ()
endIf
SpeechOff ()
JAWSCursor ()
let iXCurrentCol = GetCursorCol ()
let iYCurrentRow = GetCursorRow ()

If ((iXCurrentCol == iXPreviousCol) &&
(iYCurrentRow == iYPreviousRow)) then
SpeechOn ()
RestoreCursor ()
Return
Else
RestoreCursor ()
PerformScript Test()
EndIf
endIf
endIf
SpeechOn ()
PCCursor ()
EndFunction

Void Function PubChat ()
PCCursor ()
SpeechOff ()
{control+a}
Pause ()
MoveToWindow (GetFirstChild (GetCurrentWindow ()))
PCCursor ()
LeftMouseButton ()
Pause ()
SpeechOn ()
EndFunction

Script EnterScanNewMessages ()
let CT = true
SetJCFOption (opt_punctuation, 0)
SpeechOff ()
PubChat ()
Pause ()
PCCursor ()
SpeechOn ()
let CT = false
let DC = true
let sb = true
EndScript

Void Function ResetChat ()
let dc = false
PCCursor ()
JAWSPageDown ()
JAWSEnd ()
Pause ()
PriorWord ()
SayWord ()
NextWord ()
Pause ()
let dc = true
EndFunction

Void Function PubChatSchedule (int nX, int nY, int nOldX, int nOldY, int nUnit, int nDir, int nTimeElapsed)
If (DC == false) then
Return
else
If (DialogActive ()) then
let DC = false
Return
else
If (GetObjectType () != "Edit") then
let DC = false
Return
else
let DC = false
PCCursor ()
PriorWord ()
SayWord ()
NextWord ()
endIf
endIf
endIf
let DC = true
EndFunction

Script Play ()
let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
let prevSetting = currentSetting
let cc = GetCursorCol ()
let pc = GetCursorRow ()

SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1087))
If (GetControlID (GetCurrentWindow ()) != 1087) then
PCCursor ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf
Delay (10)
SpeechOn ()
StopSpeech ()
EndScript

Script Pause ()
let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
let prevSetting = currentSetting
let cc = GetCursorCol ()
let pc = GetCursorRow ()

SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1182))
If (GetControlID (GetCurrentWindow ()) != 1182) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf
SpeechOn ()
EndScript

Script Stop ()
let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
let prevSetting = currentSetting
let cc = GetCursorCol ()
let pc = GetCursorRow ()

SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1054))
If (GetControlID (GetCurrentWindow ()) != 1054) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf
SpeechOn ()
EndScript

Script Previous ()
var
string ToEd,
string ToEdP,
int te

let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
let prevSetting = currentSetting
let cc = GetCursorCol ()
let pc = GetCursorRow ()

SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1054))
If (GetControlID (GetCurrentWindow ()) != 1054) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf

Delay (5)
GetWord ()
let ToEd = GetWord ()
let ToEdP = ToEd
PriorLine ()
GetWord ()
let ToEd = GetWord ()
If (ToEd == ToEdP) then
let te = true
else
NextLine ()
Pause ()
endIf
If (te == true) then
NextLine ()
Pause ()
endIf
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1181))
If (GetControlID (GetCurrentWindow ()) != 1181) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
Pause ()
PriorLine ()
let cl = GetWord ()
let nl = cl
GetWord ()
PriorLine ()
let cl = GetWord ()
If (cl == nl) then
let te = true
else
NextLine ()
let te = false
endIf
endIf
Delay (10)
SpeechOn ()
StopSpeech ()
EndScript

Script NextFile ()
var
string BoEd,
string BoEdP

let currentSetting = GetDefaultJCFOption (OPT_INCLUDE_GRAPHICS)
let prevSetting = currentSetting
let cc = GetCursorCol ()
let pc = GetCursorRow ()

SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1054))
If (GetControlID (GetCurrentWindow ()) != 1054) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
endIf

Delay (5)
GetWord ()
let BoEd = GetWord ()
let BoEdP = BoEd
NextLine ()
GetWord ()
let BoEd = GetWord ()
If (BoEd == BoEdP) then
let be = true
else
PriorLine ()
Pause ()
endIf
If (be == true) then
PriorLine ()
Pause ()
endIf
RouteJAWSToPc ()
GetCursorCol ()
GetCursorRow ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveToWindow (FindDescendantWindow (GetCurrentWindow (), 1066))
If (GetControlID (GetCurrentWindow ()) != 1066) then
PCCursor ()
SpeechOn ()
Say ("Control not found", OT_STRING)
RestoreCursor ()
Return
else
PCCursor ()
LeftMouseButton ()
Pause ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
MoveTo (cc, pc)
PCCursor ()
RoutePcToJAWS ()
Pause ()
NextLine ()
let cl = GetWord ()
let nl = cl
GetWord ()
NextLine ()
let cl = GetWord ()
If (cl == nl) then
let be = true
else
PriorLine ()
let be = false
endIf
endIf
Delay (10)
SpeechOn ()
StopSpeech ()
EndScript

Script OutgoingTransfers ()
let otrans = true
SpeechOff ()
{control+t}
Pause ()
RouteJAWSToPc ()
FindString (GetCurrentWindow (), "Filename", S_BOTTOM, S_UNRESTRICTED)
JAWSCursor ()
NextLine ()
JAWSHome ()
If (GetWord () != "Clear Finished") then
PCCursor ()
LeftMouseButton ()
Pause ()
endIf
If (GetObjectType () != "List View") then
PCCursor ()
SpeechOn ()
Say ("No transfers visible", OT_STRING)
else
PCCursor ()
SpeechOn ()
SayObjectActiveItem ()
endIf
let otrans = false
EndScript

Void Function JoinR ()
let sb = false
let DC = false
SaveCursor ()
SpeechOff ()
RouteJAWSToPc ()
JAWSCursor ()
JAWSPageDown ()
JAWSEnd ()
FindString (GetCurrentWindow (), "Join", S_BOTTOM, S_UNRESTRICTED)
If (GetWord () != "Join") then
SpeechOn ()
RestoreCursor ()
Say ("key stroke temporarily invalid", OT_STRING)
else
LeftMouseButton ()
Pause ()
PCCursor ()
Delay (3)
{tab}
Pause ()
let cl = GetWord ()
let nl = cl
GetWord ()
NextLine ()
let cl = GetWord ()
If (cl != nl) then
SpeechOn ()
PriorLine ()
else
SpeechOn ()
SayObjectActiveItem ()
endIf
endIf
EndFunction

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
handle RealWindow,
string RealWindowName,
handle AppWindow

let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
let GlobalFocusWindow = FocusWindow

if ((GlobalPrevApp != AppWindow) &&
(AppWindow != FocusWindow) &&
(DialogActive ()) &&
(GetObjectType () == "Edit") &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Instant Message"))) then
If (DC == true) then
Say (GetWindowName (GetRealWindow (GetFocus ())), OT_STRING)
let DC = false
endIf
let AddUser = true
PerformScript Test()
; we've switched to a different app main window,
; and it does not have the focus, so announce it
SayWindowTypeAndText (AppWindow)
else
let AddUser = false
endIf
If ((GlobalPrevRealName != RealWindowName) ; name has changed
|| (GlobalPrevReal != RealWindow)) then ; or handle has changed, then
If ((RealWindow != AppWindow) && (RealWindow != FocusWindow)) then
SayWindowTypeAndText (RealWindow)
	endIf
endIf
if (GlobalPrevFocus != focusWindow &&
GetWindowTypeCode(focusWindow) != WT_TOOLBAR) then
if GetWindowSubTypeCode(FocusWindow) == wt_StartMenu  then
;	need to handle submenus of start menu and moving from level to level here
Else
		SayFocusedWindow () ; will use global variable GlobalFocusWindow
	EndIf
else
	SayFocusedObject ()
endIf

let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
let GlobalPrevFocus = FocusWindow
EndFunction

Script EKey ()
SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
EndScript

Script KeyTest (int NKey)
let ink = true
EndScript

Void Function ActiveItemChangedEvent (handle curHwnd, int curObjectId, int curChildId,
	handle prevHwnd, int prevObjectId, int prevChildId)
SaveCursor ()
PCCursor ()
SayObjectActiveItem()
RestoreCursor ()
EndFunction

Script ControlDownArrow ()
var
	int MenuMode,
	int TheTypeCode
Let MenuMode =  GlobalMenuMode
Let TheTypeCode = GetObjectSubtypeCode()
if IsJAWSCursor () ||
IsVirtualPCCursor () then
	PerformScript SayNextParagraph()
	return
endIf
if  DialogActive () ||((TheTypeCode == WT_TREEVIEW) ||
(TheTypeCode == WT_LISTVIEW) ||
(TheTypeCode == WT_EDITCOMBO) ||
(TheTypeCode == WT_Listbox) ||
(TheTypeCode == WT_Combobox) ||
(TheTypeCode == WT_MULTISELECT_LISTBOX) ||
(TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) ||
GetWindowClass (GetCurrentWindow ()) == wcMsoCmd then
{control + down arrow} ; move without removing selection
pause ()
Delay (1)
Say (GetObjectValue (), OT_STRING)
return
endIf
if (GetObjectTypeCode() == WT_TABCONTROL) then
	{control + down arrow}
	SayWord()
	return
endIf
if (MenuMode > 0) then
	{control + down arrow}
	return
endIf
PerformScript SayNextParagraph()
EndScript

Script ControlUpArrow ()
var
	int TheTypeCode,
	int MenuMode
Let MenuMode =  GlobalMenuMode
Let TheTypeCode = GetObjectSubTypeCode ()
if IsJAWSCursor () || IsVirtualPCCursor () then
	PerformScript SayPriorParagraph()
	return
endIf
if DialogActive () ||
((TheTypeCode == WT_TREEVIEW) ||
(TheTypeCode == WT_EDITCOMBO) ||
(TheTypeCode == WT_Listbox) ||
(TheTypeCode == WT_LISTVIEW) ||
(TheTypeCode == WT_Combobox) ||
(TheTypeCode == WT_MULTISELECT_LISTBOX) ||
(TheTypeCode == WT_EXTENDEDSELECT_LISTBOX))||
 GetWindowClass (GetCurrentWindow ()) == wcMsoCmd then
{control + up arrow} ; move without removing selection
pause ()
Delay (1)
Say (GetObjectValue (), OT_STRING)
return
endIf
if (GetObjectTypeCode() == WT_TABCONTROL) then
	SayWord()
	return
endIf
if (MenuMode > 0) then
	return
endIf
PerformScript SayPriorParagraph()
EndScript

Script SelectCurrentItem ()
var
	int TheTypeCode
SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
Pause ()
Delay (1)
Say (GetObjectValue (), OT_STRING)
EndScript

Script IgnoreUser ()
If (AddUser == true) then
SpeechOff ()
FindString (GetCurrentWindow (), "Ignore User", S_BOTTOM, S_UNRESTRICTED)
LeftMouseButton ()
Pause ()
Delay (1)
SpeechOn ()
PCCursor ()
SayWindow (GetRealWindow (GetFocus ()), 1)
endIf
EndScript

Script UserInformation ()
If (AddUser == true) then
SpeechOff ()
FindString (GetCurrentWindow (), "User Information", S_BOTTOM, S_UNRESTRICTED)
LeftMouseButton ()
Pause ()
Delay (1)
PCCursor ()

If ((DialogActive ()) &&
(StringContains (GetWindowName (GetRealWindow (GetFocus ())), "Finger"))) then
RouteJAWSToPc ()
JAWSCursor ()
SetRestriction (RestrictAppWindow)
PriorLine ()
JAWSHome ()
SetRestriction (RestrictWindow)
JAWSPageUp ()
JAWSHome ()
PCCursor ()
RoutePcToJAWS ()
Pause ()
SpeechOn ()
SayAll ()
endIf
SpeechOn ()
endIf
EndScript
